#!/bin/sh
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
# 
# http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
# License for the specific language governing rights and limitations under the License.
# 
# The Original Code is Alchitect.
# 
# The Initial Developer of the Original Code is Darrell Brogdon.
# Portions created by Darrell Brogdon are Copyright (C) 2002-2009 Darrell Brogdon.
# All Rights Reserved.
# 
# Contributor(s): .

ls -d . add_ons controllers images javascripts models pages stylesheets 2>&1 > /dev/null

if [ 1 -eq $? ]; then
	echo "This script must be run from the Alchitect directory. Exiting."
	exit 1
fi

read -p "What is the name of the web server group? " web_server_group

if [ -z ${web_server_group} ]; then
	echo "Cannot proceed without a valid web server group. Exiting."
	exit 1
fi

failed="Failed. You probably need to run this script as root (sudo ${0}). Exiting."

echo "Setting permissions..."

chgrp ${web_server_group} . controllers images javascripts logs models tmp stylesheets 2> /dev/null

if [ 1 -eq $? ];then
	echo $failed
	exit 1
fi
 
chgrp -R ${web_server_group} pages 2> /dev/null

if [ 1 -eq $? ];then
	echo $failed
	exit 1
fi

chmod -R g+w . add_ons controllers images javascripts logs models pages tmp stylesheets 2> /dev/null

if [ 1 -eq $? ];then
	echo $failed
	exit 1
fi

echo "Done!"
echo
echo "Now go to the web installer to complete the installation."
echo
