<?php
/**
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
 * License for the specific language governing rights and limitations under the License.
 * 
 * The Original Code is Alchitect Core Server.
 * 
 * The Initial Developer of the Original Code is Darrell Brogdon.
 * Portions created by Darrell Brogdon are Copyright (C) 2002-2009 Darrell Brogdon.
 * All Rights Reserved.
 * 
 * Contributor(s): .
 * 
 * @package AlchitectCoreServer
 */
ob_start('ob_gzhandler');
session_start();

include('core/server/classes/ASApplication.php');

gentime();

try
{
	ASLog::instance()->debug('==== Alchitect application started  ====');
	
	$PageRequest = ASPageRequest::instance();
	
	if ('' == $PageRequest->URLParts(ASPageRequest::AS_PAGE_REQ_URL_PART_PAGE))
	{
		header('Location: ' . APP_HREF . '/home');
		ob_end_flush();
	}
			
	ASSession::init();
	
	include($PageRequest->template());
}
catch (Exception $ex)
{
    echo '<h3 style="color:Maroon; font-family:Helvetica,Arial,Sans-Serif;">'
       . 'Alchitect Error: ' . $ex->getMessage() . "</h3>\n";
    
    if (ini_get('display_errors'))
    {
?>
<div style="background-color:Maroon;color:#efefef; font-family:Helvetica,Arial,Sans-Serif; font-weight:bold; padding:6px 3px 3px 3px;">
	Stack Trace
</div>
<div style="background-color:#efefef; border:1px solid Maroon; padding:5px;">
	<pre><?=print_r($ex->getTraceAsString(), true)?></pre>
</div>
<?php
	}
	else
	{
		ASLog::instance()->fatal($ex->getMessage());
	}
	
	exit(false);
}

ASLog::instance()->debug
(
	'==== Alchitect application finished - executed in '
	. gentime()
  . ' seconds ===='
);

ob_end_flush();

// Thanks to 'christ dot boris at nospam gmail dot com' 
// at http://us2.php.net/manual/en/function.microtime.php#85719 
// for this function.
function gentime()
{
	static $a;
	
	if ($a == 0)
	{
		$a = microtime(true);
	}
	else
	{
		return (string)(microtime(true) - $a);
	}
	
	return null;
}
?>
