<?php
/**
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
 * License for the specific language governing rights and limitations under the License.
 * 
 * The Original Code is Alchitect Core Server.
 * 
 * The Initial Developer of the Original Code is Darrell Brogdon.
 * Portions created by Darrell Brogdon are Copyright (C) 2002-2009 Darrell Brogdon.
 * All Rights Reserved.
 * 
 * Contributor(s): .
 * 
 * @package AlchitectCoreServer
 */
ob_start('ob_gzhandler');
include('server/classes/ASApplication.php');

ASLog::instance()->debug('==== Alchitect server application started  ====');

if ('XMLHttpRequest' === $_SERVER['HTTP_X_REQUESTED_WITH'])
{
	$JSON	= str_replace('\\"', '"', $_POST['json']);
	$JSON	= str_replace('\\\\"', '\\"', $JSON);
	$JSON	= str_replace("\\'", "'", $JSON);
	$JSON	= json_decode($JSON);
	$action	= $JSON->form_action;
	$page 	= $JSON->page;
		
	unset($JSON->form_action, $JSON->page);
	
	if (is_object($JSON))
	{
		foreach ($JSON as $key=>$entry)
		{
			$data[$key] = $entry;
		}
	}
	else
	{
		exit(json_encode(
			array
			(
				'code'		=> '0000'
			  , 'value'		=> false
			  , 'result'	=> 'Error'
			)
		));
	}
			
	try
	{
		$method			= 'handleJSON' . ucfirst($action);
		$PageRequest	= ASPageRequest::instance($page);
		$result			= $Controller->$method($data);
	
		echo json_encode
		(
			array
			(
				'code'		=> '0000'
			  , 'value'		=> (true !== $result ? false : true)
			  , 'result'	=> $result
			)
		);
	}
	catch (Exception $ex)
	{
		echo json_encode
		(
			array
			(
				'code'	=> $ex->getCode()
			  , 'value'	=> $ex->getMessage()
			  , 'type'	=> 'Exception'
			)
		);
	}
}
//
// The data was POSTed to this page directly so handle it accordingly.
//
else
{	 
	try
	{
		if (false == isset($_REQUEST['page']) || '' == $_REQUEST['page'])
		{
			include
			(
				ALCHITECT_CORE_SERVER_EXCEPTIONS_ROOT
			  . '/ASPageFieldNotFoundException.php'
			);
			throw new ASPageFieldNotFoundException();
		}
		else if (false == isset($_REQUEST['return_to'])
		|| 		    '' == $_REQUEST['return_to'])
		{
			include
			(
				ALCHITECT_CORE_SERVER_EXCEPTIONS_ROOT
			  . '/ASReturnToFieldNotFoundException.php'
			);
			throw new ASReturnToFieldNotFoundException();
		}
		else
		{
			$PageRequest = ASPageRequest::instance($_REQUEST['page']);
			
			header
			(
				'Location: '
			  . $_REQUEST['return_to']
			  . '/?confirmation='
			  . $PageRequest->confirmation()
			  . '&error='
			  . $PageRequest->error()
			);
		}
	}
	catch (Exception $ex)
	{
		echo 'Exception (' . $ex->getCode() . '): ' . $ex->getMessage();
	}
}

ASLog::instance()->debug('==== Alchitect server application finished  ====');
ob_end_flush();
?>
