<?php
/**
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
 * License for the specific language governing rights and limitations under the License.
 * 
 * The Original Code is Alchitect Core Server.
 * 
 * The Initial Developer of the Original Code is Darrell Brogdon.
 * Portions created by Darrell Brogdon are Copyright (C) 2002-2009 Alchisoft, LLC
 * All Rights Reserved.
 * 
 * Contributor(s): .
 * 
 * @package AlchitectCoreServer
 */
/**
 * Interface for Loader classes.
 * 
 * To be implemented for any new classes that wish to define a custom loader for a specific database.
 *
 * @author Darrell Brogdon <darrell@brogdon.net>
 * @since Wed Jul 12 14:13:05 MDT 2006 14:13:05
 * @copyright (c)2002-2009 Alchisoft, LLC
 * @package AlchitectCoreServer
 * @version $Id$
 */
interface ASActiveRecordLoader
{
	/**
	 * Load fields from the database.
	 *
	 * Loads fields (columns) from the given database for a given table.
	 *
	 * @param String $database The name of the database
	 * @param String $table The name of the table
	 * @param Resource $dbh A resource to the database handle for PDO
	 */
	function loadFields($database, $table, $dbh);
}
?>