<?php
/**
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
 * License for the specific language governing rights and limitations under the License.
 * 
 * The Original Code is Alchitect Core Server.
 * 
 * The Initial Developer of the Original Code is Darrell Brogdon.
 * Portions created by Darrell Brogdon are Copyright (C) 2002-2009 Alchisoft, LLC
 * All Rights Reserved.
 * 
 * Contributor(s): .
 * 
 * @package AlchitectCoreServer
 */
/** 
 * A generic Controller implementation.
 * 
 * All custom Controller's should extend this.
 * 
 * @author Darrell Brogdon <darrell@brogdon.net>
 * @copyright (c)2002-2009 Alchisoft, LLC
 * @package AlchitectCoreServer
 * @version $Id $
 */
class ASController extends ASMVC {
	/**
	 * The constructor.
	 * 
	 * @param ASPageRequest An instance of ASPageRequest
	 */
    public function __construct(ASPageRequest $PageRequest) {
        parent::__construct($PageRequest);
        
        $this->PageRequest = $PageRequest;
        
        $this->initModel();
    }
    
    /**
     * Initialize the Model associated with this Controller
     * 
     * Optionally accepts an already instantiated instace of ASModel.  This is
     * so that when you want to override ASModel you should call 
     * <pre>parent::initModel($ModelName)</pre> instead of redefining 
     * initMode().
     * 
     * @access public
     * @param ASModel An instance of a subclassed ASModel.
     * @return Void
     */
    public function initModel($model=null)
    {
    	$this->Model = $GLOBALS['Model'] =
    	(
    		is_null($model) 
    	  ? new ASModel($this->PageRequest->pageName()) 
    	  : $model
    	);
    }
}
?>