<?php
/**
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
 * License for the specific language governing rights and limitations under the License.
 * 
 * The Original Code is Alchitect Core Server.
 * 
 * The Initial Developer of the Original Code is Darrell Brogdon.
 * Portions created by Darrell Brogdon are Copyright (C) 2002-2009 Alchisoft, LLC.
 * All Rights Reserved.
 * 
 * Contributor(s): .
 * 
 * @package AlchitectCoreServer
 */
/**
 * Exception to be thrown when session authentication fails.  Usually means
 * someone tampered with the session data and ASSession::authUser() returned 
 * false.
 *
 * @author Darrell Brogdon <darrell@brogdon.net>
 * @copyright (c)2002-2009 Alchisoft, LLC
 * @package AlchitectCoreServer
 * @version $Id: $
 * @see ASSession
 */
class ASInvalidSessionException extends ASException
{
	protected $message	= 'The page you were trying to access could not be loaded because the session was invalid.';
	protected $code		= 0x3e8;
	
	/**
	 * 
	 *@param String message 
	 *@param Integer code 
	 */
	public function __construct()
	{
		parent::__construct($this->message, $this->code);
	}
}
?>