<?php
set_include_path(get_include_path() . ':../..');
include_once('simpletest/unit_tester.php');
include_once('../classes/ASPageRequest.php');

class ASPageRequestTest extends UnitTestCase
{
	function __construct()
	{
		parent::UnitTestCase("ASPageRequest Test");
	}
	
	function setUp()
	{
		$this->ASPageRequest	= ASPageRequest::instance();
	}
	
	function testAction()
	{
		$this->assertEqual('insert', $this->ASPageRequest->action());
	}
	
	function testAppName()
	{
		$this->assertEqual('', $this->ASPageRequest->appName());
	}
	
	function testPageAppName()
	{
		$this->assertEqual('home', $this->ASPageRequest->pageAppName());
	}
	
	function testPathToAction()
	{
		$this->assertEqual('server/unit_tests/app/home/', $this->ASPageRequest->pathToAction());
	}
	
	function testBaseHref()
	{
		$this->assertEqual('server/unit_tests/', BASE_HREF);
	}
	
	function testConfirmation()
	{
		$this->assertEqual('', $this->ASPageRequest->confirmation());
	}
	
	function testError()
	{
		$this->assertEqual('', $this->ASPageRequest->error());
	}
	
	function testFormActionURL()
	{
		$this->assertEqual('server/unit_tests/index.php/home/insert', $this->ASPageRequest->formActionURL());
	}
	
	function testGetIncludePage()
	{
		$this->assertEqual('pages/home/insert.php', $this->ASPageRequest->getIncludePage());
	}
	
	function testId()
	{
		$this->assertEqual('', $this->ASPageRequest->id());
	}
	
	function testInitController()
	{
		$this->ASPageRequest->initController('');

		$this->assertTrue(isset($GLOBALS['Controller']));
		$this->assertIsA($GLOBALS['Controller'], 'Controller');
	}
	
	function testInitModel()
	{
		$this->ASPageRequest->initModel('Foo');

		$this->assertTrue(isset($GLOBALS['FooModel']));
		$this->assertIsA($GLOBALS['FooModel'], 'FooModel');
	}
	
	function testPageClassName()
	{
		$this->assertEqual('Home', $this->ASPageRequest->pageClassName());
	}
	
	function testPageName()
	{
		$this->assertEqual('home', $this->ASPageRequest->pageName());
	}
	
	function testSetAction()
	{
		$this->ASPageRequest->setAction('test');
		
		$this->assertEqual('test', $this->ASPageRequest->action());
	}
	
	function testSetBaseHref()
	{
		$this->ASPageRequest->setBaseHref('/foo/bar/baz');
		
		$this->assertEqual('/foo/bar/baz', BASE_HREF);
	}
	
	function testSetConfirmation()
	{
		$this->ASPageRequest->setConfirmation('confirmed');
		
		$this->assertEqual('confirmed', $this->ASPageRequest->confirmation());
	}
	
	function testSetError()
	{
		$this->ASPageRequest->setError('failed');
		
		$this->assertEqual('failed', $this->ASPageRequest->error());
	}
	
	function testSetId()
	{
		$this->ASPageRequest->setId('my_id');
		
		$this->assertEqual('my_id', $this->ASPageRequest->id());
	}
	
	function testSetPageName()
	{
		$this->ASPageRequest->setPageName('my_page');
		
		$this->assertEqual('my_page', $this->ASPageRequest->pageName());
	}
	
	function testUrlData()
	{
		$this->assertIsA($this->ASPageRequest->urlData(), 'array');
	}
}
?>
