$(function()
{
	AS_FORM.registerHook(verificationHook);
	AS_FORM.registerFormSubmittedCallback(form_submitted);
});

/**
 * Callback function to be executed after the form has been submitted, the XHR
 * request has been made, and data is ready to be acted upon.
 *
 * @param Object The XHR response data object
 * @param String The XHR response string
 */
function form_submitted(data, status)
{	
	if (false == data.value)
	{
		$('#error').html('Failed to update - Please try again').show();
	}
	else if ('Exception' == data.type)
	{
		$('#error').html('ERROR (' + data.code + '): ' + data.value).show();
	}
	else
	{
		$('#confirmation').html('Information has been updated').show();

		if ('delete' == $('#form_action').val())
		{
			window.history.back();
		}
	}
}

/**
 * Verify the the password confirmation value matches the password value.
 *
 * @param Object The form object.
 */
function verificationHook(frm)
{
	if ('delete' == $('#form_action').val())
	{
		return true;
	}
	
	// 
	// Perform the verification here
	// 

	$('#password').parent().removeClass('error_input');
	$('#confirm_password').parent().removeClass('error_input');

	return true;
}